package asd.td2;

import asd.base.*;

/**
 * Une classe pour l'exercice 3 de la feuille 2.
 *  2002 Marc Gatano
 */
public class ChaineEquilibree {

    String s; // la chane  tester

    /**
     * Construit un objet ChaineEquilibree pour tester si
     * la chane chaine est quilibre.
     * Complexit : O(1).
     */
    public ChaineEquilibree(String chaine) {
	s = chaine;
    }

    /**
     * Retourne true si c est un des caractres
     * '(', '{' ou '[', false sinon.
     * Complexit : O(1).
     */
    private boolean ouvrant(char c) {
        return c == '(' || c == '{' || c == '[';
    }

    /**
     * Retourne true si c est un des caractres
     * ')', '}' ou ']', false sinon.
     * Complexit : O(1).
     */
    private boolean fermant(char c) {
        return c == ')' || c == '}' || c == ']';
    }

    /**
     * Retourne cc, tel que cc est le caractre ouvrant
     * correspondant au caractre fermant c.
     * Prcondition : fermant(c) = true.
     * Complexit : O(1).
     */
    private char lOuvrant(char c) {
        switch ( c ) {
        case ')':
            return '(';
        case '}':
            return '{';
        default:
            return '[';
        }
    }

    /**
     * Teste si une chaine est equilibre.
     * Complexit : O(n) o n = longueur de la chane.
     */
    public boolean equilibree() {
	return false;
    }

    // pour se simplifier la vie

    private void empiler(char c, PileStatique p) {
        p.empiler(new Character(c));
    }

    private void depiler(PileStatique p) {
        p.depiler();
    }

    private char sommet(PileStatique p) {
        return ((Character) p.sommet()).charValue();
    }

    private boolean vide(PileStatique p) {
        return p.vide();
    }
}
